'' 1/16/16 test with parallax joystick
'' TestRcDecay.spin  
''2/22/16 changed to use mcp3208 for joystick and button 
CON
   
  _clkmode = xtal1 + pll16x                  
  _xinfreq = 5_000_000   

dpin = 3    'both din and dout
cpin = 5    'clock pin 
spin = 1    'chip select pin 

VAR
  
  byte cogjs
  long stackjs[50], F_B, R_L, B_P

OBJ

 '   pst : "Parallax Serial Terminal"
    adc     : "MCP3208" 
  
PUB Start : okay
 
 ' pst.Start(115_200)       
  adc.start(dpin, cpin, spin, 255)  'Start the MCP3208 object and enable all 8 channels as
                                    'single-ended inputs.   
  Stop
  okay := (cogjs := cognew(Inputs, @stackjs) + 1)  
                                            
PUB Stop                                                   

    If cogjs 
      cogstop(cogjs~ - 1)

PUB Inputs       
  
  repeat
    
    F_B := adc.in(0)   
    Case  F_B 
      0..20       : F_B := 16   'back
      21..380     : F_B := 15 
      381..585    : F_B := 14 
      586..826    : F_B := 13 
      827..1190   : F_B := 12 
      1191..1540  : F_B := 11      
      1541..2060  : F_B := 10 
      2061..2281  : F_B := 9  
      2282..2315  : F_B := 0    'midpoint
      2316..2700  : F_B := 1  
      2701..3070  : F_B := 2          
      3071..3230  : F_B := 3
      3231..3360  : F_B := 4
      3361..3500  : F_B := 5
      3501..3770  : F_B := 6
      3771..4070  : F_B := 7
      4071..4095  : F_B := 8    'forward       
          
 '   pst.Str(String(pst#cs, pst#NL, pst#HM, "F_B channel 0= "))  
 '   pst.Dec(F_B)                           
  
    R_L := adc.in(1) 
    Case  R_L
      0..30      : R_L := 16      'left
      31..370    : R_L := 15 
      371..540   : R_L := 14 
      541..710   : R_L := 13 
      711..850   : R_L := 12 
      851..1020  : R_L := 11      
      1021..1430 : R_L := 10
      1431..2184 : R_L := 9
      2185..2205 : R_L := 0     'midpoint
      2206..2600 : R_L := 1
      2601..2800 : R_L := 2
      2801..2990 : R_L := 3
      2991..3200 : R_L := 4
      3201..3490 : R_L := 5
      3491..3700 : R_L := 6
      3701..4093 : R_L := 7       
      4094..4095 : R_L := 8        'right      
          
'    pst.Str(String(pst#NL, "R_L channel 1= ")) 
 '   pst.Dec(R_L)                        

    B_P := adc.in(3)
    if B_P == 4095
      B_P := 1
    else
      B_P := 0           
    waitcnt(clkfreq/10 + cnt)   'delay is needed
    
'    pst.Str(String(pst#NL, "B_P = "))
'    pst.Dec(B_P)
 
PUB getFB
  return F_B
  
PUB getRL
  return R_L

PUB getBP
  return B_P
    